<?php

require __DIR__.'/Tupac.php';
use Ivysaur\Tupac;

// 

function check($mode) {
	$all_success = true;
	
	for ($a = 0; $a < 10; ++$a) {
		for ($b = 0; $b < 10; ++$b) {
			$packed = Tupac::pack($a, $b, $mode);
			list($a_recovered, $b_recovered) = Tupac::unpack($packed, $mode);
			
			if ($a !== $a_recovered || $b !== $b_recovered) {
				echo "Test failure for $a , $b recovered $a_recovered , $b_recovered \n";
				$all_success = false;
			}
		}
	}
	
	if ($all_success) {
		echo "Test successful\n\n";
	}
}

function drawchart($mode) {
	for($y = 10; $y --> 0;) {
		echo sprintf("%4d | ", $y);
		for($x = 0; $x < 10; ++$x) {
			echo sprintf("%4d", Tupac::pack($x, $y, $mode));
		}
		echo "\n";
	}
	echo "\n";
}

drawchart( Tupac::MODE_BINARY );

check(Tupac::MODE_BINARY);

drawchart( Tupac::MODE_DIAGONAL ); 

check(Tupac::MODE_DIAGONAL);
